<!DOCTYPE html>
<html lang="en">
  <head>
    <title>A small introduction to three.js webgl [1]</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, user-scalable=no, minimum-scale=1.0, maximum-scale=1.0">
    <link rel="stylesheet" href="css/basic.css">
  
    <script src="three.js"></script>
    <script src="js/OrbitControls.js"></script>
    <script src="js/Detector.js"></script>
    <script type="text/javascript">
      
      // Checks that your browser supports WebGL. 
      if ( ! Detector.webgl ) Detector.addGetWebGLMessage();
      
      var renderer = null;
      var controls = null; 
      var scene    = null;
      var camera   = null;
      var cube     = null;
      var sphere   = null;
      var earth   = null;
      var moon   = null;
      var earthGroup = null;
      var moonGroup = null;
      var cameraAngle = null;
      var curTime  = Date.now();
      
      // This function is called whenever the document is loaded
      function init() {
		// Get display canvas
		var canvas = document.getElementById("webglcanvas");
		console.log( canvas );

		// Create the Three.js renderer and attach it to our canvas
		renderer = new THREE.WebGLRenderer( { canvas: canvas,
						antialias: true } );
		// Set the viewport size
		renderer.setSize( canvas.width, canvas.height );

		renderer.shadowMap.enabled = true;
		// rendu coûteux mais plus joli (default: THREE.PCFShadowMap)
		renderer.shadowMap.type = THREE.PCFSoftShadowMap; 

		// Create a new Three.js scene
		scene = new THREE.Scene();
		// Add  a camera so we can view the scene
		camera = new THREE.PerspectiveCamera( 45, canvas.width / canvas.height,
						1, 4000 );
		
		//Controls
		controls = new THREE.OrbitControls( camera, renderer.domElement );
		//controls.addEventListener( 'change', render ); // call this only in static scenes (i.e., if there is no animation loop)
		controls.enableDamping = true; // an animation loop is required when either damping or auto-rotation are enabled
		controls.dampingFactor = 0.25;
		controls.screenSpacePanning = false;
		controls.minDistance = 1;
		controls.maxDistance = 20;

		
		//Sun
		//Texture
		var mapSun = new THREE.TextureLoader().load( "images/sun.jpg" );
		//Material
		var materialSun = new THREE.MeshBasicMaterial({map : mapSun});

		//Geometry
		var geometrySun = new THREE.SphereGeometry(1, 50, 50);

		//Put the geometry and material together into a mesh
		sun = new THREE.Mesh(geometrySun, materialSun);

		// Move the mesh back from the camera and tilt it toward the viewer
		sun.position.set(0,0,0);

		//Add sun to the scene
		scene.add(sun);

		// Add a white point light
		light = new THREE.PointLight( 0xffffff, 1.5);
		light.position.set(0,0,0);
		light.castShadow = true;
		// On peut aussi paramétrer la qualité du calcul
		light.shadow.mapSize.width = 512;  // default
		light.shadow.mapSize.height = 512; // default
		light.shadow.camera.near = 0.5;    // default
		light.shadow.camera.far = 50;
		scene.add( light );

		//Earth
		
		//Material
		var mapEarth = new THREE.TextureLoader().load( "images/earth_atmos_2048.jpg" );
		var earthMaterial = new THREE.MeshPhongMaterial({map : mapEarth});

		//Geometry
		var geometryEarth = new THREE.SphereGeometry(0.5, 50, 50);

		//Put the geometry and material together into a mesh
		earth = new THREE.Mesh(geometryEarth, earthMaterial);

		// Move the mesh back from the camera and tilt it toward the viewer
		earth.position.set(3,0,-1);
		earth.rotation.x = Math.PI / 5;
		earth.rotation.y = Math.PI / 5;

		
		//Moon
		
		//Texture
		var mapMoon = new THREE.TextureLoader().load( "images/moon.png" );
		//Material
		var moonMaterial = new THREE.MeshPhongMaterial({map : mapMoon});

		//Geometry
		var geometryMoon = new THREE.SphereGeometry(0.2, 50, 50);

		//Put the geometry and material together into a mesh
		moon = new THREE.Mesh(geometryMoon, moonMaterial);

		// Move the mesh back from the camera and tilt it toward the viewer
		moon.position.set(-1,0,0);

		moonGroup = new THREE.Group();
		moonGroup.position.set(3,0,-1);
		moonGroup.add(moon);
		
		earthGroup =new THREE.Group();
		earthGroup.add(earth);
		earthGroup.add(moonGroup);

		scene.add(earthGroup);

		camera.position.set(0,0,-10);
		cameraAngle = 0;
		//controls.target = earth.position;

		// Add background		
		var textureCube    = new THREE.TextureLoader().load( "images/background.jpg" );
		textureCube.format = THREE.RGBFormat;
		scene.background   = textureCube;

		earth.castShadow = true;
		earth.receiveShadow = true;
		moon.castShadow = true;
		moon.receiveShadow = true;
      }
      
      // This function is called regularly to update the canvas webgl.
      function run() {
		  // Ask to call again run 
		  requestAnimationFrame( run );
		  
		  // Render the scene
		  render();
		  
		  // Calls the animate function if objects or camera should move
		  animate();
      }
      
      // This function is called regularly to take care of the rendering.
      function render() {
		  // Render the scene
		  renderer.render( scene, camera );
      }
      
      // This function is called regularly to update objects.
      function animate() {
      	

		// Computes how time has changed since last display
		var now       = Date.now();
		var deltaTime = now - curTime;
		curTime       = now;
		var fracTime  = deltaTime / 1000; // in seconds
		
		// Now we can move objects, camera, etc.
		var angle = Math.PI * 2 * fracTime; // one turn per 10 second.
		earthGroup.rotation.y += angle / 365; // la terre tourne en 365 jours
		earth.rotation.y      += angle; // et en un jour sur elle-même
		moonGroup.rotation.y  += angle / 28; // la lune tourne en 28 jours autour de la terre
		moon.rotation.y       += angle /28; // et en 28 jours aussi sur elle-même pour faire face à la terre

		camera.lookAt(earth.matrixWorld.getPosition());
		controls.update();


		cameraAngle = 5;
		// Avec un grand demi-axe de 5 et un petit demi-axe de 3
		//camera.position.x = 5 * Math.cos( cameraAngle );
		//camera.position.y = 3 * Math.sin( cameraAngle );


		
      }
      
    </script>
  </head>
  <body>
    <div id="info"> a first three.js example </div>
    <canvas id="webglcanvas" style="border: none;background-color:#000000"
	    width="600" height="500"></canvas>
    <!-- We run the WebGL code at the end to be sure that the document is loaded.
      -->
    <script>
      init(); run();
    </script> 
  </body>
</html>

